
boolean getUserSerial() {
  EEPROMindex = 0;
  inputstring.reserve(15);
  digitalWrite (readyLED, HIGH);
  if (!getIntro())
    return 0;
  digitalWrite(buzzerPin, HIGH);
  delay(20);
  digitalWrite(buzzerPin, LOW);
  if (inputstring == "R") {

    readALlFromChip();

    return 0;
  }
  if (inputstring == "N") {
    strcpy (name, wantedFile);
    Serial.println("Programming Started");

    digitalWrite (readyLED, LOW);
    if (!startProgramming ())
    {
      ShowMessage (MSG_CANNOT_ENTER_PROGRAMMING_MODE);
      return;
    }  // end of could not enter programming mode

    //FUSES ARE BURNED HERE!!!
    // WOULD BE NICE IF WE COULD DETERMINE FUSE SETTINGS BASED ON SIGNATURE
    writeFuse (0xFF, writeLowFuseByte);
    stopProgramming();
    startProgramming ();
    //writeFuse (0xD6, writeHighFuseByte);//retains EEPROM
    writeFuse (0xDE, writeHighFuseByte);
    stopProgramming();
    startProgramming ();
    writeFuse (0x05, writeExtendedFuseByte);//BO at 2.7V
    stopProgramming();
    startProgramming ();
    getSignature ();
    for (int k = 0; k < strlen_P(fuseBurn); k++)
    {
      char myChar =  pgm_read_byte_near(fuseBurn + k);
      Serial.print(myChar);
    }
    getFuseBytes ();
    // don't have signature? don't proceed
    if (foundSig == -1)
    {
      ShowMessage (MSG_CANNOT_FIND_SIGNATURE);
      return;
    }  // end of no signature

    digitalWrite (workingLED, HIGH);
    bool ok = writeFlashContents ();
    digitalWrite (workingLED, LOW);
    digitalWrite (readyLED, LOW);
    stopProgramming ();
    //delay (500);
    if (ok) {
      //ShowMessage (MSG_FLASHED_OK);
      for (int i = 0; i < 10; i++) {
        digitalWrite(buzzerPin, HIGH);
        delay(50);
        digitalWrite(buzzerPin, LOW);
        delay(50);
      }
    }
    Serial.println("Programming Complete!");

  }

  digitalWrite (readyLED, HIGH);
  digitalWrite(buzzerPin, HIGH);
  delay(20);
  digitalWrite(buzzerPin, LOW);

  if (!getDate())
    return 0;
  digitalWrite(buzzerPin, HIGH);
  delay(20);
  digitalWrite(buzzerPin, LOW);
 
  for (int i = 0; i < 10; i++) {
    digitalWrite(buzzerPin, HIGH);
    delay(20);
    digitalWrite(buzzerPin, LOW);
    delay(20);
  }
  Serial.println("DONE!\n\n");
  readALlFromChip();
  return 0;

}




void burnEEPROM(byte EEPROMdata) {
  startProgramming();
  digitalWrite(workingLED, HIGH);
  program (writeEEPROMbyte, 0, EEPROMindex, EEPROMdata);
  delay(100);
  digitalWrite(workingLED, LOW);
  stopProgramming();
}


boolean getDate() {
  inputstring = "";
  //Serial.println("Please Enter Date like this: MM/DD/YY");
  for (int k = 0; k < strlen_P(dateMessage); k++)
  {
    char myChar =  pgm_read_byte_near(dateMessage + k);
    Serial.print(myChar);
  }
  getString();
  if (inputstring.length() > 8 || inputstring.length() < 8) {
    for (int k = 0; k < strlen_P(wrongLength); k++)
    {
      char myChar =  pgm_read_byte_near(wrongLength + k);
      Serial.print(myChar);
    }
    // Serial.println("Sorry wrong length");
    return 0;
  }
  Serial.print("Thanks, will use ");
  Serial.println(inputstring);
  for (int i = 0; i < 8; i++) {
    burnEEPROM(inputstring[i]);
    EEPROMindex++;
  }
  return 1;
}


boolean getIntro() {
  inputstring = "";
  for (int k = 0; k < strlen_P(introMessage); k++)
  {
    char myChar =  pgm_read_byte_near(introMessage + k);
    Serial.print(myChar);
  }

  getString();
  if (inputstring.length() > 1 || inputstring.length() < 1) {
    for (int k = 0; k < strlen_P(wrongLength); k++)
    {
      char myChar =  pgm_read_byte_near(wrongLength + k);
      Serial.print(myChar);
    }
    return 0;
  }

  return 1;
}

void getString() {
  inputstring = "";
  //digitalWrite (readyLED, LOW);
  unsigned long blinkerStart = millis();
  while (1) {
    if (millis() - blinkerStart > 50) {
      digitalWrite(readyLED, !digitalRead(readyLED));
      blinkerStart = millis();
    }

    if (digitalRead (startSwitch) == LOW) {
      inputstring = "N";
      break;
    }

    if (Serial.available() > 0) {
      delay(10);
      inputstring = Serial.readStringUntil(13);           //read the string until we see a <CR>
      //Serial.println(inputstring);
      digitalWrite (readyLED, HIGH);
      //digitalWrite(workingLED, LOW);
      break;
    }
  }
}

void readALlFromChip() {

  if (!startProgramming ()) {
    Serial.println("NO BOARD DETECTED!!");
    return;
  }
  Serial.println("***** Reading From Board *****");
  Serial.println("Config Fuses Set:");
  getFuseBytes ();
  //startProgramming();
  Serial.println("");
  //    Serial.println("Reading Board Data...");
  Serial.print("Date Prog = ");
  byte indexTracker = 0;
  for (byte i = 0; i < 8; i++) {
    Serial.print(char(program (readEEPROMbyte, 0, i)));
    indexTracker++;
  }
  Serial.println("");
 
  Serial.print("Firmware Date Code = ");
  for (byte i = indexTracker; i < indexTracker + 8; i++) {
    Serial.print(char(program (readEEPROMbyte, 0, i)));
  }

  stopProgramming();
  Serial.println("");
  Serial.println("*********************");
  Serial.println("\n");
}
